package cn.fw.dalaran.domain.db;

import cn.fw.common.data.entity.BaseAuditableTimeEntity;
import lombok.Data;
import lombok.EqualsAndHashCode;
import lombok.ToString;

/**
 * @author kurisu
 * @date 2021-11-16 11:14
 * @description :
 */
@EqualsAndHashCode(callSuper = true)
@Data
@ToString(callSuper = true)
public class TodoHistory extends BaseAuditableTimeEntity<TodoHistory, Long> {
    /**
     * 用户id
     */
    private Long userId;
    /**
     * 门店id
     */
    private Long shopId;
    /**
     * 是否已发送
     */
    private Boolean send;
    /**
     * 是否已完成
     */
    private Boolean done;
    /**
     * 待办是否完成
     */
    private Boolean todoDone;
    /**
     * 待办码
     */
    private String todoCode;
    /**
     * 业务id
     */
    private Long dataId;
    /**
     * 附加信息
     */
    private String extra;

    /**
     * 自定义去重条件
     */
    public String getRemoveDuplicatesCondition() {
        return this.getUserId() + "-->" + this.getDataId();
    }
}
