package cn.fw.dalaran.domain.dto;

import cn.fw.common.page.BasePageQuery;
import cn.fw.dalaran.domain.enums.PlatformEnum;
import lombok.Data;
import lombok.EqualsAndHashCode;
import lombok.ToString;

import java.util.Objects;

/**
 * 查询条件
 *
 *@author kurisu
 */

@Data
@ToString(callSuper = true)
@EqualsAndHashCode(callSuper = true)
public class AccountQueryDTO extends BasePageQuery {
    /**
     * 平台类型
     */
    private Integer type;
    /**
     * 是否有效
     */
    private Integer valid;
    /**
     * 门店id
     */
    private Long shopId;
    /**
     * 人员id
     */
    private Long userId;
    /**
     * 人员名
     */
    private String userName;

    public PlatformEnum getType() {
        if (Objects.isNull(type)) {
            return null;
        }
        return PlatformEnum.ofValue(type);
    }

    public Boolean getValid() {
        if (Objects.isNull(valid) || valid <= 0) {
            return null;
        }
        return valid == 1;
    }
}
