package cn.fw.dalaran.service.data;

import cn.fw.dalaran.domain.db.ConfigGroup;
import cn.fw.dalaran.domain.vo.ConfigGroupVo;
import com.baomidou.mybatisplus.extension.service.IService;

import java.util.List;

/**
 * @author wmy3969
 * @version 1.0
 * @date 2022-4-28 16:23:44
 * @Description
 */
public interface ConfigGroupService extends IService<ConfigGroup> {
    /**
     * 初始化一个配置组
     *
     * @param userId  用户id
     * @param groupId 集团id
     * @return
     */
    ConfigGroupVo init(Long userId, Long groupId);

    /**
     * 更新配置组
     *
     * @param userId 用户id
     * @param param  参数封装
     * @return
     */
    boolean update(Long userId, ConfigGroupVo param);

    /**
     * 查询本集团的配置组列表
     *
     * @param userId  用户id
     * @param groupId 集团id
     * @return
     */
    List<ConfigGroupVo> queryList(Long userId, Long groupId);
}
