package stringCompare;

import org.junit.Test;

/**
 * 最长公共子序列（Longest common subsequence）
 */
public class LCS {

    @Test
    public void test1() {
        /*String x = "春风十鲤鱼焕新鲸喜";
        String y = "春❥(^_-)风❥(^_-)十❥(^_-)里❥(^_-)焕❥(^_-)新❥(^_-)鲸❥(^_-)喜 长安CS75, 5.1限时活动";*/
        String x = "abcxd";
        String y = "acnda";
        int m = x.length();
        int n = y.length();
        int[][] c = new int[m + 1][n + 1];// 创建⼆维数组, 记录填表过程
        int[][] path = new int[m + 1][n + 1];// 记录通过哪个⼦问题解决的, 也就是递推的路径
        for (int i = 1; i < m + 1; i++) {
            for (int j = 1; j < n + 1; j++) {
                if (x.charAt(i - 1) == y.charAt(j - 1)) {
                    c[i][j] = c[i - 1][j - 1] + 1;
                } else if (c[i - 1][j] >= c[i][j - 1]) {
                    c[i][j] = c[i - 1][j];
                    path[i][j] = 1;
                } else {
                    c[i][j] = c[i][j - 1];
                    path[i][j] = 2;
                }
            }
        }
        // 输出查看c
        System.out.println("c:");
        for (int i = 0; i < m + 1; i++) {
            for (int j = 0; j < n + 1; j++) {
                System.out.print(c[i][j] + "\t");
            }
            System.out.println();
        }
        // 输出查看path
        System.out.println("path:");
        for (int i = 0; i < m + 1; i++) {
            for (int j = 0; j < n + 1; j++) {
                System.out.print(path[i][j] + "\t");
            }
            System.out.println();
        }
        System.out.println("最长公共子序列的长度：" + c[x.length()][y.length()]);
        System.out.print("最长公共⼦序列为：");
        printLCS(path, x, m, n);
        System.out.println();
        System.out.println(result);
    }

    private String result = "";

    public void printLCS(int[][] b, String x, int i, int j) {
        if (i == 0 || j == 0) {
            return;
        }
        if (b[i][j] == 0) {
            printLCS(b, x, i - 1, j - 1);
            System.out.printf("%c", x.charAt(i - 1));
            result += x.charAt(i - 1);// 取出最大子序列
        } else if (b[i][j] == 1) {
            printLCS(b, x, i - 1, j);
        } else {
            printLCS(b, x, i, j - 1);
        }
    }

}
